#!/usr/bin/perl -w

use strict;
use warnings;

use CGI;
my $q = new CGI;


# create the body of the page
print $q->header;
print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<HEAD>
    <TITLE>CCamelOT - An OT-CC implementation</TITLE>
    
    <LINK rel="stylesheet" type="text/css" href="mich.css" />
    <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
</HEAD>

<BODY LEFTMARGIN=0 TOPMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
EOF


# read nav bar
open (NAV, "<navbar.txt") or die "Can't read navbar. $!";
print while (<NAV>);
close(NAV);

print <<"EOF";

<DIV CLASS="pagebody">

    <DIV CLASS="title">About CCamelOT</DIV>
    <BR>
    CCamelOT is a Perl/JavaScript implementation of OT-CC by <A HREF="http://people.umass.edu/mbe/">Michael Becker</A>.<BR>
    <BR>
    OT-CC is first presented in McCarthy, John J. (forthcoming) <I>Hidden Generalizations: Phonological Opacity in Optimality Theory.</I> London: Equinox Publishing Company.<BR>
    <BR>



    You may cite CCamelOT as follows:<BR>
    Becker, Michael (2005) CCamelOT web application, http://people.umass.edu/mbe/CCamelOT/<BR>
    <BR>
    You can download the code from the <A HREF="needCON.cgi#myself">I need a constraint!</A> page.<BR>
    <BR>


    <DIV CLASS="subtitle">Acknowledgments</DIV>
    <BR>

        For their valuable feedback and ideas, I would like to thank
        Tim           Beechey,
        Kathryn       Flack,
        Peter         Jurgec,
        Shigeto       Kawahara,
        Mike          Key,
        John          Kingston,
        John          McCarthy,
        Joe           Pater,
        Chris         Potts,
        Anne-Michelle Tessier and
        Matt          Wolf.

        Special thanks go to Kathryn Flack,
        John McCarthy and Matt Wolf for their helpful comments
        on several versions of CCamelOT.
    
        
        I am also grateful to the audience at the LSA 80th Annual meeting
        in Albuquerque, especially Luigi Burzio, Jason Riggle, Donca Steriade
        and Adam Wayment.

	Thanks also to the audience at the Tel Aviv University linguistics department colloquium, 
	especially to  Outi Bat-El, 
			Tal Keidar, 
			Chuck Kisseberth,	
			Fred Landman and 
			Omer Preminger. 
        
        Thanks to Youri Zabbal for technical help.<BR>
    <BR>
    I found much inspiration in two programs that do OT-related things:<BR>
    <A HREF="http://www.linguistics.ucla.edu/people/hayes/otsoft/">OTSoft</A> by Bruce Hayes, Bruce Tesar, and Kie Zuraw.<BR>
    <A HREF="http://www.fon.hum.uva.nl/praat/">PRAAT</A> by Paul Beorsma and David Weenink.<BR>

</DIV>

EOF

# read footer
open (FTR, "<footer.txt") or die "Can't read footer. $!";
print while (<FTR>);
close(FTR);


print <<"EOF";
</BODY>
</HTML>

EOF
