#!/usr/bin/perl -w

use strict;
use warnings;

use CGI;
my $q = new CGI;
use CGI::Cookie;
use URI::Escape;

use Fcntl qw(:flock);



# read cookies
my %cookies = fetch CGI::Cookie;

#read current user
my $userEmail = $cookies{userEmail} || "";
$userEmail = uri_unescape(($userEmail =~ /^userEmail=([^;]*);/)[0]) || "";


my $foundPost = 0;
my $CONid = 0;

my $postMsg = "";
my $postErr = "";


if ($q->param("CONid")) {
	
	$foundPost = 1;
	
	die "Record number not found.   $!" if ($q->param("CONid") !~ /\d+/);
	
	$CONid = $q->param("CONid") || "";
	
	$postErr = "Operation could not be completed because data was missing (.CONid)"  unless ($CONid>0);
	
	if ($postErr eq "") {
	
		open (CONS,  "<" . "data/CONs.txt")     or die "Can't read CONs file. $!";
		open (CONS2, ">" . "data/CONs_new.txt") or die "Can't write to COns file. $!";
		
		flock(CONS, LOCK_EX);
		flock(CONS2,LOCK_EX);
		
		my $foundLine = 0;
		my $foundUser = 0;
		
		while (<CONS>) {
			my $id = (/^id=(\d+);/)[0];
			if ($id==$CONid) {
				$foundLine = 1;
				if (/\;email=$userEmail\;/) {
					$foundUser = 1;
				} else {
					# don't delete unless user email matches current user
					print CONS2;
				}
			} else {
				print CONS2;
			}
		}
		
		close(CONS);
		close(CONS2);
		rename("data/CONs_new.txt", "data/CONs.txt");
		
		unless ($foundLine) {
			$postMsg = "The record you wanted to delete could not be found." ;
		} else {
			$postMsg = "You can only delete posts that you posted yourself. You have to be logged in for the system to recogize you." unless ($foundUser);
		}
	}    
}


if (($postErr eq "") and ($postMsg eq "") and $foundPost) {
    print $q->redirect(-uri=>'CONs.cgi');
}















# create the body of the page
print $q->header;
print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<HEAD>
    <TITLE>CCamelOT - An OT-CC implementation</TITLE>
    
    <LINK rel="stylesheet" type="text/css" href="mich.css" />
    <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    
    <SCRIPT src="toolbox.js" type="text/javascript"></SCRIPT>
</HEAD>

<BODY LEFTMARGIN=0 TOPMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>


EOF

# read nav bar
open (NAV, "<navbar.txt") or die "Can't read navbar. $!";
print while (<NAV>);
close(NAV);

print "<DIV STYLE='padding-left:16px;padding-right:16px;'>\n";

if ($foundPost) {

	if ($postErr) {
		print "<SPAN CLASS='errorMsg'>" , $postErr , "</SPAN><BR>\n"
	} else {
		print "<SPAN CLASS='errorMsg'>" , $postMsg , "</SPAN><BR>";
	}

} else {
	print "<SPAN CLASS='errorMsg'>No post specified for deletion.</SPAN><BR>\n"
}

print "<BR><BR>";
# read footer
open (FTR, "<footer.txt") or die "Can't read footer. $!";
print while (<FTR>);
close(FTR);

print <<"EOF";

</DIV>
</BODY>
</HTML>

EOF

