#!/usr/bin/perl -w

use strict;
use warnings;

use CGI;
my $q = new CGI;
use CGI::Cookie;
use URI::Escape;

use Fcntl qw(:flock);

use Phoneme;
use Link;
use MakeHTML;


# read cookies
my %cookies = fetch CGI::Cookie;

# sets phonetic alphabet
my $alphabet = $cookies{alphabet} || "";
$alphabet = ($alphabet =~ /^alphabet=([^;]*);/)[0] || "";
$alphabet = "APAU" unless ($alphabet =~ /^[IA]PA[U]?$/);
sub unicode { return (index($alphabet,"U")!=-1) ? "U" : ""; }
setAlphabet($alphabet);


# read nav bar
my $navStr;
open (NAV, "<navbar.txt") or die "Can't read navbar. $!";
$navStr .= $_ while (<NAV>);
close(NAV);

# create the body of the page
print $q->header;
print <<"EOF";
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<HTML xmlns="http://www.w3.org/1999/xhtml" lang="en-US" xml:lang="en-US">
<HEAD>
    <TITLE>CCamelOT - An OT-CC implementation</TITLE>
    
    <LINK rel="stylesheet" type="text/css" href="mich.css" />
    <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    
    <SCRIPT src="Phoneme.js" type="text/javascript"></SCRIPT>

</HEAD>

<BODY LEFTMARGIN=0 TOPMARGIN=0 MARGINWIDTH=0 MARGINHEIGHT=0>
<FORM>

$navStr

<DIV CLASS="pagebody">

	Choose a phonetic alphabet:<BR>


EOF

	my $alph = ($alphabet =~ /IPA/) ? "IPA" : "APA";
	my $font = ($alphabet =~ /U/) ? "U" : "";
	
	if ($alph eq "APA") {
	    print "<INPUT TYPE='radio' NAME='alphabet' CHECKED> American Phonetic Alphabet (APA) <BR>";
	    print "<INPUT TYPE='radio' NAME='alphabet' onClick='setAlphabet(\"IPA\",\"$font\");location.reload()'> International Phonetic Alphabet (IPA)<BR>";
	} else {
	    print "<INPUT TYPE='radio' NAME='alphabet' onClick='setAlphabet(\"APA\",\"$font\");location.reload()'> American Phonetic Alphabet (APA) <BR>";
	    print "<INPUT TYPE='radio' NAME='alphabet' CHECKED> International Phonetic Alphabet (IPA)<BR>";
	}
	
	
	print "<BR>Choose a phonetic font: (<A HREF='help.cgi#fonts'>Where do I get these fonts?</A>)<BR>";
	
	if ($font eq "U") {
	    print "<INPUT TYPE='radio' NAME='font' CHECKED> Doulos SIL / Gentium<BR>";
	    print "<INPUT TYPE='radio' NAME='font' onClick='setAlphabet(\"$alph\",\"\");location.reload()'> SILDoulos IPA93<BR>";
	} else {
	    print "<INPUT TYPE='radio' NAME='font' onClick='setAlphabet(\"$alph\",\"U\");location.reload()'> Doulos SIL / Gentium<BR>";
	    print "<INPUT TYPE='radio' NAME='font' CHECKED> SILDoulos IPA93<BR>";
	}



print <<"EOF";

	<BR>
	Test:<BR>
	<TABLE CELLSPACING=0 CELLPADDING=6 BORDER=0 CLASS="tableau1">
	<TR STYLE="height:3em;">
		<TD CLASS="tableau2">What your browser is displaying:</TD>
		<TD CLASS="tableau2" ALIGN="center">
		<SPAN STYLE='font-size:150%;line-height:150%'>
		<SCRIPT>
			var alphabet = "$alphabet";
			setAlphabet("$alph","$font");
	
			var html = (alphabet.indexOf("U")!=-1) ? "<SPAN CLASS='segmentU'>" : "<SPAN CLASS='segment'>";
			html += seg["ch"].symbol;
			html += seg["uumlaut"].symbol;
			html += seg["y"].symbol;
			html += "</SPAN>";
			document.write(html);
			document.close();
		</SCRIPT>
		</SPAN>
		</TD>
	</TR>
	<TR STYLE="height:3em;">
		<TD CLASS="tableau2">What you should be seeing:</TD>
		<TD CLASS="tableau2"><IMG SRC="images/$alphabet.gif" ALIGN="baseline"></TD>
	</TR>
	</TABLE>

	If the font you chose is properly installed, the text and the image will match.
	You should see the symbols for a post-alveolar affricate, a high front rounded vowel, and a palatal glide.<BR>


</DIV>
</FORM>

EOF


# read footer
open (FTR, "<footer.txt") or die "Can't read footer. $!";
print while (<FTR>);
close(FTR);


print <<"EOF";
</BODY>
</HTML>

EOF
